# Copyright (C) 2020 Adek Maulana
#
# SPDX-License-Identifier: GPL-3.0-or-later
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import os

from selenium import webdriver
from selenium.webdriver.chrome.options import Options

import pyAyiin


class Chrome:
    async def chrome(self: "pyAyiin.pyAyiin", chrome_options=None):
        if chrome_options is None:
            chrome_options = await self.options()
        if not os.path.isdir(self.TEMP_DOWNLOAD_DIRECTORY):
            os.mkdir(self.TEMP_DOWNLOAD_DIRECTORY)
        prefs = {"download.default_directory": self.TEMP_DOWNLOAD_DIRECTORY}
        chrome_options.add_experimental_option("prefs", prefs)
        return webdriver.Chrome(
            executable_path=self.CHROME_DRIVER,
            options=chrome_options)


    async def options(self: "pyAyiin.pyAyiin"):
        chrome_options = Options()
        chrome_options.binary_location = self.GOOGLE_CHROME_BIN
        chrome_options.add_argument("--headless")
        chrome_options.add_argument("--window-size=1920x1080")
        chrome_options.add_argument("--disable-dev-shm-usage")
        chrome_options.add_argument("--no-sandbox")
        chrome_options.add_argument("--disable-gpu")
        return chrome_options
